(* XorShift

Ver, 1.00 2012/06/15 

XorShift ASYɂ[NXB

TXorShift
XorShift [NX

vpeB
RandSeed; ̌f[^B

\bh
Init;      RandSeed B
Randomize; oߎԂg RandSeed B
Random:    𐶐B

   XorShift ^ *)

unit XorShift;

interface

uses
  Winapi.Windows;

type
  TXorShift = class(TObject)
  private
    { Private 錾 }
    FSeeds: Array[0..3] of Cardinal;  //^ x, y, z, w
    FSeed: Cardinal;
    procedure SetRandSeed(const ASeed: Cardinal);
  public
    { Public 錾 }
    constructor Create(ASeed: Cardinal); overload;
    constructor Create; overload;
    procedure Init;
    procedure Randomize;
    function Random: Cardinal;  overload;
    function Random(const ARange: Integer): Integer; overload;
    property RandSeed: Cardinal read FSeed write SetRandSeed;
  end;

implementation

constructor TXorShift.Create(ASeed: Cardinal);
begin
  inherited Create;

  RandSeed := ASeed;
end;

constructor TXorshift.Create;
begin
  Create(1);
end;

procedure TXorShift.SetRandSeed(const ASeed: Cardinal);
var
  i: Cardinal;
begin
  if FSeed = ASeed then Exit;

  FSeed := ASeed;
  for i := 0 to 3 do
  begin
    FSeed := 1812433253 * (FSeed xor (FSeed shr 30)) + (i + 1);
    FSeeds[i] := FSeed;
  end;
  FSeed := ASeed;
end;

procedure TXorShift.Init;
begin
  FSeeds[0] := 123456789;
  FSeeds[1] := 362436069;
  FSeeds[2] := 521288629;
  FSeeds[3] := 88675123;
end;

procedure TXorShift.Randomize;
begin
  RandSeed := GetTickCount;
end;

function TXorShift.Random: Cardinal;
var
  t: Cardinal;
begin
  t := FSeeds[0] xor (FSeeds[0] shl 11);
  FSeeds[0] := FSeeds[1];
  FSeeds[1] := FSeeds[2];
  FSeeds[2] := FSeeds[3];
  FSeeds[3] := (FSeeds[3] xor (FSeeds[3] shr 19)) xor (t xor (t shr 8));
  Result := FSeeds[3];
end;

function TXorShift.Random(const ARange: Integer): Integer;
begin
  Result := Trunc(ARange * (1.0 / 4294967296.0) * Self.Random);
end;

end.
